/*-----------------------------------------------------------------------*/
/*                                   TIGA                                */
/*         Copyright (C) 1988-1990  Texas Instruments Incorporated.      */
/*                           All Rights Reserved                         */
/*-----------------------------------------------------------------------*/
/*  TIGA - Header file                                                   */
/*-----------------------------------------------------------------------*/
/*                                                                       */
/*  file            gsptiga.h (GSP-C equivalent of tiga.h)               */
/*                                                                       */
/*  description     This file contains references to TIGA core functions */
/*                  It is needed for the gsp side of an application,     */
/*                  written in GSP-C, which invokes TIGA core functions. */
/*                                                                       */
/*-----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*  Reference Core Primitives                                           */
/*----------------------------------------------------------------------*/
extern          void   clear_frame_buffer();
extern          void   clear_page();
extern          void   clear_screen();
extern          void   cop2gsp();
extern          short  cpw();
extern          long   cvxyl();
extern          void   flush_extended();
extern          short  flush_module();
extern          short  function_implemented();
extern          void   get_colors();
extern          void   get_config();
extern          short  get_curs_state();
extern          void   get_curs_xy();
extern          short  get_fontinfo();
extern          void   get_isr_priorities();
extern          long   get_nearest_color();
extern          void   get_offscreen_memory();
extern          void   get_palet();
extern          short  get_palet_entry();
extern unsigned long   get_pmask();
extern unsigned short  get_ppop();
extern          void   get_text_xy();
extern          short  get_transp();
extern unsigned long   get_vector();        
extern          short  get_windowing();
extern          short  get_wksp();
extern          void   gsp2cop();
extern          void   gsp2gsp();
extern unsigned short  gsph_alloc();
extern unsigned short  gsph_calloc();
extern          void   gsph_compact();
extern          long   gsph_deref();
extern unsigned short  gsph_falloc();
extern unsigned short  gsph_fcalloc();
extern unsigned short  gsph_findhandle();
extern          short  gsph_findmem();
extern          void   gsph_free();
extern          void   gsph_init();
extern          long   gsph_maxheap();
extern          void   gsph_memtype();
extern          long   gsph_realloc();
extern          long   gsph_totalfree();
extern          long   gsp_calloc();
extern          short  gsp_free();
extern          long   gsp_malloc();
extern          long   gsp_maxheap();
extern          void   gsp_minit();
extern          long   gsp_realloc();
extern          void   init_palet();
extern          void   init_text();
extern          short  lmo();
extern          short  page_busy();
extern          void   page_flip();
extern          long   peek_breg();
extern          void   poke_breg();
extern          short  rmo();
extern          void   set_bcolor();
extern          void   set_clip_rect();
extern          void   set_colors();
extern          short  set_config();
extern          void   set_curs_shape();
extern          void   set_curs_state();
extern          void   set_cursattr();
extern          void   set_fcolor();
extern          short  set_interrupt();
extern          short  set_module_state();
extern          void   set_palet();
extern          short  set_palet_entry();
extern          void   set_pmask();
extern          void   set_ppop();
extern          void   set_text_xy();
extern          void   set_transp();
extern unsigned long   set_vector();
extern          void   set_windowing();
extern          void   set_wksp();
extern          short  sym_flush();
extern          short  text_out();
extern          void   text_outp();
extern          void   transp_off();
extern          void   transp_on();
extern          void   wait_scan();

/*----------------------------------*/
/* Callback Packet Definitions      */
/*----------------------------------*/
#define __WORD(a)           0,2,a
#define __DWORD(a)          0,4,a
#define __BYTE_PTR(a,b)     1,a,b
#define __WORD_PTR(a,b)     1,a*2,b
#define __ALTBYTE_PTR(a,b)  129,a,b
#define __ALTWORD_PTR(a,b)  129,a*2,b
#define __INBYTE_PTR(a,b)   161,a,b
#define __INWORD_PTR(a,b)   161,a*2,b
#define __STRING(a)         65,a

/*----------------------------------*/
/* Colors of the default TIGA palet */
/*----------------------------------*/
#define  BLACK          0
#define  BLUE           1
#define  GREEN          2
#define  CYAN           3
#define  RED            4
#define  MAGENTA        5
#define  BROWN          6
#define  LIGHT_GRAY     7
#define  DARK_GRAY      8
#define  LIGHT_BLUE     9
#define  LIGHT_GREEN    10
#define  LIGHT_CYAN     11
#define  LIGHT_RED      12
#define  LIGHT_MAGENTA  13
#define  YELLOW         14
#define  WHITE          15

/*----------------------------------*/
/* Memory System Equates            */
/*----------------------------------*/
#define TRUE    1
#define FALSE   0
#define BLK_DELETABLE   0x01    /* Block can be deleted */
#define BLK_LOCKED      0x02    /* Block is locked */
#define BLK_FUNCMOVE    0x04    /* Call block function on move */
#define BLK_FUNCDELETE  0x08    /* Call block function on purge */
#define BLK_SECURED     0x10    /* Block is secured memory */
#define BLK_INUSE       0x20    /* Block is allocated */

/*----------------------------------*/
/* Extended primitives module id    */
/* - parameter to sym_flush         */
/*----------------------------------*/
#define GRAPHICS_LIB_ID 0x3C00
