;-------------------------------------------------------------------------;
;                                    TIGA                                 ;
;          Copyright (C) 1989-1990  Texas Instruments Incorporated.       ;
;                            All Rights Reserved                          ;
;-------------------------------------------------------------------------;
;   TIGA - Include file                                                   ;
;-------------------------------------------------------------------------;
;                                                                         ;
;   file                tiga.inc (uSoft-Assembler version of tiga.h)      ;
;                                                                         ;
;   description         This is the main include file defining TIGA core  ;
;                       primitives and should be included in every uSoft  ;
;                       assembler application that interfaces to TIGA.    ;
;                                                                         ;
;-------------------------------------------------------------------------;
; 02/08/89      Original Version                        Richard Churchill ;
; 03/14/89      Rewritten                               Graham Short      ;
; 07/27/89      Adjusted                                Randy Spurlock    ;
; 04/23/90      Added _DOUBLE packet type defs          W.S.Egr           ;
; 10/25/90      Fixed Get_Palet (invalid ax usage)      W.S.Egr           ;
; 10/25/90      Mod $CALL to handle palette hooks       W.S.Egr           ;
;-------------------------------------------------------------------------;

;-------------------------------------------------------------------------;
;   Reference Host-side entry points                                      ;
;-------------------------------------------------------------------------;
        Extrn   _tiga_set:Far
        Extrn   _cp_alt:Far
        Extrn   _cp_alt_a:Far
        Extrn   _cp_cmd:Far
        Extrn   _cp_cmd_a:Far
        Extrn   _cp_ret:Far
        Extrn   _cp_ret_a:Far
        Extrn   _create_alm:Far
        Extrn   _create_esym:Far
        Extrn   _dm_cmd:Far
        Extrn   _dm_palt:Far
        Extrn   _dm_pcmd:Far
        Extrn   _dm_ipoly:Far
        Extrn   _dm_pget:Far
        Extrn   _dm_poly:Far
        Extrn   _dm_pret:Far
        Extrn   _dm_psnd:Far
        Extrn   _dm_pstr:Far
        Extrn   _dm_ptrx:Far
        Extrn   _dm_ret:Far
        Extrn   _field_extract:Far
        Extrn   _field_insert:Far
        Extrn   _flush_esym:Far
        Extrn   _get_memseg:Far
        Extrn   _get_msg:Far
        Extrn   _get_modeinfo:Far
        Extrn   _get_vector:Far
        Extrn   _get_videomode:Far
        Extrn   _get_xstate:Far
        Extrn   _gm_is_alive:Far
        Extrn   _gsp_execute:Far
        Extrn   _gsp2host:Far
        Extrn   _gsp2hostxy:Far
        Extrn   _handshake:Far
        Extrn   _host2gsp:Far
        Extrn   _host2gspxy:Far
        Extrn   _install_alm:Far
        Extrn   _install_primitives:Far
        Extrn   _install_rlm:Far
        Extrn   _install_usererror:Far
        Extrn   _loadcoff:Far
        Extrn   _makename:Far
        Extrn   _oem_init:Far
        Extrn   _read_hstadrh:Far
        Extrn   _read_hstadrl:Far
        Extrn   _read_hstaddr:Far
        Extrn   _read_hstctl:Far
        Extrn   _read_hstdata:Far
        Extrn   _rstr_commstate:Far
        Extrn   _save_commstate:Far
        Extrn   _set_config:Far
        Extrn   _set_curs_shape:Far
        Extrn   _set_curs_xy:Far
        Extrn   _set_memseg:Far
        Extrn   _set_msg:Far
        Extrn   _set_timeout:Far
        Extrn   _set_vector:Far
        Extrn   _set_videomode:Far
        Extrn   _set_xstate:Far
        Extrn   _synchronize:Far
        Extrn   _write_hstadrh:Far
        Extrn   _write_hstadrl:Far
        Extrn   _write_hstaddr:Far
        Extrn   _write_hstctl:Far
        Extrn   _write_hstdata:Far
        Extrn   _aux_command:Far
        Extrn   _setup_hostcmd:Far
        Extrn   _hook_init_pal:Far
        Extrn   _hook_get_near:Far
        Extrn   _hook_get_pal:Far
        Extrn   _hook_set_pal:Far
        Extrn   _hook_get_pal_e:Far
        Extrn   _hook_set_pal_e:Far

;-------------------------------------------------------------------------;
;   Define local variables used in the macro calculations                 ;
;-------------------------------------------------------------------------;
$Stack_Count    =       0               ; Number of bytes on the stack
$Parm_Count     =       0               ; Number of parameters in c-packet call
$Last_Valid     =       0               ; Last push value valid flag
$Last_Value     =       0               ; Last push value
;-------------------------------------------------------------------------;
;   Define macros used in Host functions and Direct Mode functions        ;
;-------------------------------------------------------------------------;

$Push           Macro   Value
        If      (.Type (Value)) And 00000100b
                If      $Last_Valid
                        If      (Value) Ne $Last_Value
                                 mov     ax,Value
                        Endif
                Else
                        mov     ax,Value
$Last_Valid     =       1
                Endif
$Last_Value     =       Value
                push    ax
        Else
                push    Value
        Endif
                Endm

$Word           Macro   Value
        $Push   <Value>
$Stack_Count    =       $Stack_Count + 2
                Endm

$Dword          Macro   High, Low
        Ifnb    <Low>
                $Push   <High>
                $Push   <Low>
        Else
                $Push   <Seg High>
                $Push   <Offset High>
        Endif
$Stack_Count    =       $Stack_Count + 4
                endm

$Call           Macro   Entry, Number
        Ifb     <Number>
                call    Far Ptr Entry
                If      $Stack_Count
                        add     sp,$Stack_Count
                Endif
        Else
$Parm_Count     =       0
                Ifidn   <Entry>,<_dm_cmd>
$Parm_Count     =       1
                Else
                    Ifidn   <Entry>,<_dm_ret>
$Parm_Count     =       1
                    Else
                        Ifidn   <Entry>,<_hook_get_near>
$Parm_Count     =       1
                        Else
                            Ifidn   <Entry>,<_hook_set_pal_e>
$Parm_Count     =       1
                            Else
                                Ifidn   <Entry>,<_hook_init_pal>
$Parm_Count     =       1
                                Endif
                            Endif
                        Endif
                    Endif
                Endif
                If      $Parm_Count
                        mov     ax,$Stack_Count Shr 1
                        push    ax
                Endif
                If      (.Type (Number)) And 00000100b
                        mov     ax,Number
                        push    ax
                Else
                        push    Number
                Endif
                call    Far Ptr Entry
                If      $Parm_Count
                        add     sp,$Stack_Count + 4
                Else
                        add     sp,$Stack_Count + 2
                Endif
        Endif
$Stack_Count    =       0
$Parm_Count     =       0
$Last_Valid     =       0
                Endm

;-------------------------------------------------------------------------;
;   Define macros used in "C" packet data types                           ;
;-------------------------------------------------------------------------;

_Word           Macro   Value
        $Push   <Value>
        mov     ax,2
        push    ax
        mov     ax,0
        push    ax
$Stack_Count    =       $Stack_Count + 6
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_Sword          Macro   Value
        $Push   <Value>
        mov     ax,2
        push    ax
        push    ax
$Stack_Count    =       $Stack_Count + 6
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_Dword          Macro   High, Low
        $Push   <High>
        $Push   <Low>
        mov     ax,4
        push    ax
        mov     ax,0
        push    ax
$Stack_Count    =       $Stack_Count + 8
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_Double         Macro   w3,w2,w1,w0
        $Push   w3
        $Push   w2
        $Push   w1
        $Push   w0
        mov     ax,8
        push    ax
        mov     ax,4
        push    ax
$Stack_Count    =       $Stack_Count + 12
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_Byte_Ptr       Macro   Length, Ptr_Seg, Ptr_Off
        $Push   <Ptr_Seg>
        $Push   <Ptr_Off>
        $Push   <Length>
        mov     ax,1
        push    ax
$Stack_Count    =       $Stack_Count + 8
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_Word_Ptr       Macro   Length, Ptr_Seg, Ptr_Off
        $Push   <Ptr_Seg>
        $Push   <Ptr_Off>
        mov     ax,Length
        shl     ax,1
        push    ax
        mov     ax,1
        push    ax
$Stack_Count    =       $Stack_Count + 8
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_Dword_Ptr      Macro   Length, Ptr_Seg, Ptr_Off
        $Push   <Ptr_Seg>
        $Push   <Ptr_Off>
        mov     ax,Length
        shl     ax,1
        shl     ax,1
        push    ax
        mov     ax,1
        push    ax
$Stack_Count    =       $Stack_Count + 8
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_Double_Ptr     Macro   len,ptrseg,ptroff
        $Push   ptrseg
        $Push   ptroff
        mov     ax,len
        shl     ax,1
        shl     ax,1
        shl     ax,1
        push    ax
        mov     ax,4+1
        push    ax
$Stack_Count    =       $Stack_Count + 8
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_String         Macro   Ptr_Seg, Ptr_Off
        $Push   <Ptr_Seg>
        $Push   <Ptr_Off>
        mov     ax,0
        push    ax
        mov     ax,65
        push    ax
$Stack_Count    =       $Stack_Count + 8
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_AltByte_Ptr    Macro   Length, Ptr_Seg, Ptr_Off
        $Push   <Ptr_Seg>
        $Push   <Ptr_Off>
        $Push   <Length>
        mov     ax,129
        push    ax
$Stack_Count    =       $Stack_Count + 8
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_AltWord_Ptr    Macro   Length, Ptr_Seg, Ptr_Off
        $Push   <Ptr_Seg>
        $Push   <Ptr_Off>
        mov     ax,Length
        shl     ax,1
        push    ax
        mov     ax,129
        push    ax
$Stack_Count    =       $Stack_Count + 8
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_AltDword_Ptr   Macro   Length, Ptr_Seg, Ptr_Off
        $Push   <Ptr_Seg>
        $Push   <Ptr_Off>
        mov     ax,Length
        shl     ax,1
        shl     ax,1
        push    ax
        mov     ax,129
        push    ax
$Stack_Count    =       $Stack_Count + 8
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_AltDouble_Ptr  Macro   len,ptrseg,ptroff
        $Push   ptrseg
        $Push   ptroff
        mov     ax,len
        shl     ax,1
        shl     ax,1
        shl     ax,1
        push    ax
        mov     ax,128+4+1
        push    ax
$Stack_Count    =       $Stack_Count + 8
$Parm_Count     =       $Parm_Count + 1
$Last_Valid     =       0
                Endm

_Call           Macro   Entry, Number
        mov     ax,$Parm_Count
        push    ax
        If      (.Type (Number)) And 00000100b
                mov     ax,Number
                push    ax
        Else
                push    Number
        Endif
        call    Far Ptr Entry
        add     sp,$Stack_Count + 4
$Stack_Count    =       0
$Parm_Count     =       0
$Last_Valid     =       0
                Endm

;-------------------------------------------------------------------------;
;   Define command number modifiers                                       ;
;-------------------------------------------------------------------------;
CORE_CP         Equ     07E00h
CORE_DM         Equ     03E00h
EXT_CP          Equ     07C00h
EXT_DM          Equ     03C00h
USER_CP         Equ     04000h
USER_DM         Equ     00000h

;-------------------------------------------------------------------------;
;   Core host functions                                                   ;
;-------------------------------------------------------------------------;

Tiga_Set                Macro   __command
        $Word           <__command>
        $Call           _tiga_set
                        Endm

Create_ALM              Macro   __rlmhi, __rlmlo, __almhi, __almlo
        $Dword          <__almhi>, <__almlo>
        $Dword          <__rlmhi>, <__rlmlo>
        $Call           _create_alm
                        Endm

Create_ESYM             Macro
        $Call           _create_esym
                        Endm

Field_Extract           Macro   __gptrhi, __gptrlo, __fs
        $Word           <__fs>
        $Dword          <__gptrhi>, <__gptrlo>
        $Call           _field_extract
                        Endm

Field_Insert            Macro  __gptrhi, __gptrlo, __fs, __datahi, __datalo
        $Dword          <__datahi>, <__datalo>
        $Word           <__fs>
        $Dword          <__gptrhi>, <__gptrlo>
        $Call           _field_insert
                        Endm

Flush_ESYM              Macro
        $Call           _flush_esym
                        Endm

Get_MemSeg              Macro   __addrlohi, __addrlolo, __addrhihi, __addrhilo
        $Dword          <__addrhihi>, <__addrhilo>
        $Dword          <__addrlohi>, <__addrlolo>
        $Call           _get_memseg
                        Endm

Get_ModeInfo            Macro   __index, __modehi, __modelo
        $Dword          <__modehi>, <__modelo>
        $Word           <__index>
        $Call           _get_modeinfo
                        Endm

Get_Msg                 Macro
        $Call           _get_msg
                        Endm

Get_Vector              Macro   __trap
        $Word           <__trap>
        $Call           _get_vector
                        Endm

Get_VideoMode           Macro
        $Call           _get_videomode
                        Endm

Get_XState              Macro
        $Call           _get_xstate
                        Endm

GM_Is_Alive             Macro
        $Call           _gm_is_alive
                        Endm

GSP_Execute             Macro   __ephi, __eplo
        $Dword          <__ephi>, <__eplo>
        $Call           _gsp_execute
                        Endm

GSP2Host                Macro   __gptrhi, __gptrlo, __hptrhi, __hptrlo, __length, __swizzle
        $Word           <__swizzle>
        $Word           <__length>
        $Dword          <__hptrhi>, <__hptrlo>
        $Dword          <__gptrhi>, <__gptrlo>
        $Call           _gsp2host
                        Endm

GSP2HostXY              Macro   __sahi,__salo,__sphi,__splo,__dahi,__dalo,__dphi,__dplo,__sx,__sy,__dx,__dy,__xe,__ye,__ps,__sw
        $Word           <__sw>
        $Word           <__ps>
        $Word           <__ye>
        $Word           <__xe>
        $Word           <__dy>
        $Word           <__dx>
        $Word           <__sy>
        $Word           <__sx>
        $Dword          <__dphi>, <__dplo>
        $Dword          <__dahi>, <__dalo>
        $Dword          <__sphi>, <__splo>
        $Dword          <__sahi>, <__salo>
        $Call           _gsp2hostxy
                        Endm

HandShake               Macro
        $Call           _handshake
                        Endm

Host2GSP                Macro   __hptrhi, __hptrlo, __gptrhi, __gptrlo, __length, __swizzle
        $Word           <__swizzle>
        $Word           <__length>
        $Dword          <__gptrhi>, <__gptrlo>
        $Dword          <__hptrhi>, <__hptrlo>
        $Call           _host2gsp
                        Endm

Host2GSPXY              Macro   __sahi,__salo,__sphi,__splo,__dahi,__dalo,__dphi,__dplo,__sx,__sy,__dx,__dy,__xe,__ye,__ps,__sw
        $Word           <__sw>
        $Word           <__ps>
        $Word           <__ye>
        $Word           <__xe>
        $Word           <__dy>
        $Word           <__dx>
        $Word           <__sy>
        $Word           <__sx>
        $Dword          <__dphi>, <__dplo>
        $Dword          <__dahi>, <__dalo>
        $Dword          <__sphi>, <__splo>
        $Dword          <__sahi>, <__salo>
        $Call           _host2gspxy
                        Endm

Install_ALM             Macro   __almhi, __almlo
        $Dword          <__almhi>, <__almlo>
        $Call           _install_alm
                        Endm

Install_Primitives      Macro
        $Call           _install_primitives
                        Endm

Install_RLM             Macro   __rlmhi, __rlmlo
        $Dword          <__rlmhi>, <__rlmlo>
        $Call           _install_rlm
                        Endm

Install_UserError       Macro   __funchi, __funclo
        $Dword          <__funchi>, <__funclo>
        $Call           _install_usererror
                        Endm

LoadCoff                Macro   __filehi, __filelo
        $Dword          <__filehi>, <__filelo>
        $Call           _loadcoff
                        Endm

OEM_Init                Macro   __sizehi, __sizelo
        $Dword          <__sizehi>, <__sizelo>
        $Call           _oem_init
                        Endm

Read_HSTADRL            Macro
        $Call           _read_hstadrl
                        Endm

Read_HSTADRH            Macro
        $Call           _read_hstadrh
                        Endm

Read_HSTADDR            Macro
        $Call           _read_hstaddr
                        Endm

Read_HSTCTL             Macro
        $Call           _read_hstctl
                        Endm

Read_HSTDATA            Macro
        $Call           _read_hstdata
                        Endm

RSTR_CommState          Macro
        $Call           _rstr_commstate
                        Endm

Save_COMMState          Macro
        $Call           _save_commstate
                        Endm

Set_Config              Macro   __mode, __draw
        $Word           <__draw>
        $Word           <__mode>
        $Call           _set_config
                        Endm

Set_Curs_Shape          Macro   __shapehi, __shapelo
        $Dword          <__shapehi>, <__shapelo>
        $Call           _set_curs_shape
                        Endm

Set_Curs_XY             Macro   __x, __y
        $Word           <__y>
        $Word           <__x>
        $Call           _set_curs_xy
                        Endm

Set_MemSeg              Macro   __addrlohi, __addrlolo, __addrhihi, __addrhilo
        $Dword          <__addrhihi>, <__addrhilo>
        $Dword          <__addrlohi>, <__addrlolo>
        $Call           _set_memseg
                        Endm

Set_Msg                 Macro   __msg
        $Word           <__msg>
        $Call           _set_msg
                        Endm

Set_TimeOut             Macro   __value
        $Word           <__value>
        $Call           _set_timeout
                        Endm

Set_Vector              Macro   __trap, __addrhi, __addrlo
        $Dword          <__addrhi>, <__addrlo>
        $Word           <__trap>
        $Call           _set_vector
                        Endm

Set_VideoMode           Macro   __mode, __style
        $Word           <__style>
        $Word           <__mode>
        $Call           _set_videomode
                        Endm

Set_XState              Macro   __opt
        $Word           <__opt>
        $Call           _set_xstate
                        Endm

Synchronize             Macro
        $Call           _synchronize
                        Endm

Write_HSTADRL           Macro   __val
        $Word           <__val>
        $Call           _write_hstadrl
                        Endm

Write_HSTADRH           Macro   __val
        $Word           <__val>
        $Call           _write_hstadrh
                        Endm

Write_HSTADDR           Macro   __hi, __lo
        $Dword          <__hi>, <__lo>
        $Call           _write_hstaddr
                        Endm

Write_HSTCTL            Macro   __val
        $Word           <__val>
        $Call           _write_hstctl
                        Endm

Write_HSTDATA           Macro   __val
        $Word           <__val>
        $Call           _write_hstdata
                        Endm

;-------------------------------------------------------------------------;
;   Core function Command Numbers                                         ;
;-------------------------------------------------------------------------;
cmADD_INTERRUPT         Equ     CORE_CP Or  0
cmDEL_INTERRUPT         Equ     CORE_CP Or  1
cmFUNCTION_IMPLEMENTED  Equ     CORE_CP Or  2
cmGET_COLORS            Equ     CORE_CP Or  3
cmGET_CONFIG            Equ     CORE_CP Or  4
cmGSP_MAXHEAP           Equ     CORE_CP Or  6
cmGET_OFFSCREEN_MEMORY  Equ     CORE_CP Or  7
cmGET_PALET_ENTRY       Equ     CORE_CP Or  8
cmGET_PMASK             Equ     CORE_CP Or  9
cmGET_PPOP              Equ     CORE_CP Or 10
cmGET_TRANSP            Equ     CORE_CP Or 11
cmGET_WINDOWING         Equ     CORE_CP Or 12
cmGSP_CALLOC            Equ     CORE_CP Or 13
cmGSP_FREE              Equ     CORE_CP Or 14
cmGSP_MALLOC            Equ     CORE_CP Or 15
cmGSP_MINIT             Equ     CORE_CP Or 16
cmGSP_REALLOC           Equ     CORE_CP Or 17
cmINIT_CURSOR           Equ     CORE_CP Or 18
cmSET_CONFIG            Equ     CORE_CP Or 20
cmPAGE_FLIP             Equ     CORE_CP Or 21
cmSET_PALET             Equ     CORE_CP Or 22
cmTRANSP_OFF            Equ     CORE_CP Or 23
cmTRANSP_ON             Equ     CORE_CP Or 24
cmVIDEO_ENABLE          Equ     CORE_CP Or 25
cmGET_STATE             Equ     CORE_CP Or 26
cmCLEAR_SCREEN          Equ     CORE_DM Or 27
cmGET_NEAREST_COLOR     Equ     CORE_DM Or 28
cmGET_PALET             Equ     CORE_CP Or 29
cmGSP2GSP               Equ     CORE_DM Or 30
cmINIT_PALET            Equ     CORE_DM Or 31
cmLMO                   Equ     CORE_DM Or 32
cmPALLOC                Equ     CORE_DM Or 33
cmPEEK_BREG             Equ     CORE_DM Or 34
cmPOKE_BREG             Equ     CORE_DM Or 35
cmRMO                   Equ     CORE_DM Or 36
cmSET_BCOLOR            Equ     CORE_DM Or 37
cmSET_COLORS            Equ     CORE_DM Or 38
cmSET_FCOLOR            Equ     CORE_DM Or 39
cmSET_INTERRUPT         Equ     CORE_CP Or 40
cmSET_PALET_ENTRY       Equ     CORE_DM Or 41
cmSET_PMASK             Equ     CORE_DM Or 42
cmSET_PPOP              Equ     CORE_DM Or 43
cmSET_WINDOWING         Equ     CORE_DM Or 44
cmSET_CLIP_RECT         Equ     CORE_DM Or 45
cmWAIT_SCAN             Equ     CORE_CP Or 46
cmSET_WKSP              Equ     CORE_DM Or 47
cmADD_MODULE            Equ     CORE_CP Or 48
cmDEL_MODULE            Equ     CORE_CP Or 49
cmDEL_ALL_MODULES       Equ     CORE_CP Or 50
cmGET_ISR_PRIORITIES    Equ     CORE_CP Or 51
cmINIT_INTERRUPTS       Equ     CORE_CP Or 52
cmSET_CURS_SHAPE        Equ     CORE_DM Or 53
cmSET_CURS_STATE        Equ     CORE_DM Or 54
cmGET_CURS_STATE        Equ     CORE_CP Or 55
cmGET_CURS_XY           Equ     CORE_CP Or 56
cmFLUSH_EXTENDED        Equ     CORE_CP Or 57
cmPAGE_BUSY             Equ     CORE_CP Or 58
cmCLEAR_FRAME_BUFFER    Equ     CORE_DM Or 59
cmCLEAR_PAGE            Equ     CORE_DM Or 60
cmGET_WKSP              Equ     CORE_CP Or 61
cmCPW                   Equ     CORE_DM Or 62
cmINIT_TEXT             Equ     CORE_CP Or 63
cmTEXT_OUT              Equ     CORE_CP Or 64
cmGET_FONTINFO          Equ     CORE_CP Or 65
cmGET_MODULE            Equ     CORE_CP Or 66
cmCVXYL                 Equ     CORE_DM Or 67
cmSET_CURSATTR          Equ     CORE_DM Or 68
cmCOP2GSP               Equ     CORE_CP Or 69
cmGSP2COP               Equ     CORE_CP Or 70
cmSET_TRANSP            Equ     CORE_DM Or 71
cmGET_TEXT_XY           Equ     CORE_CP Or 72
cmSET_TEXT_XY           Equ     CORE_DM Or 73
cmTEXT_OUTP             Equ     CORE_DM Or 74
cmHBM_DEREF             Equ     CORE_CP Or 76
cmHBM_SETMEMTYPE        Equ     CORE_CP Or 77
cmHBM_ALLOC             Equ     CORE_CP Or 78
cmHBM_FALLOC            Equ     CORE_CP Or 79
cmHBM_FREE              Equ     CORE_CP Or 80
cmHBM_TOTALFREE         Equ     CORE_CP Or 81
cmHBM_MAXHEAP           Equ     CORE_CP Or 82
cmHBM_COMPACT           Equ     CORE_CP Or 83
cmHBM_REALLOC           Equ     CORE_CP Or 84
cmHBM_FINDMEM           Equ     CORE_CP Or 85
cmHBM_INIT              Equ     CORE_CP Or 86
cmHBM_FINDHANDLE        Equ     CORE_CP Or 87
cmSYM_OPEN              Equ     CORE_CP Or 90
cmSYM_CLOSE             Equ     CORE_CP Or 91
cmSYM_PUT               Equ     CORE_CP Or 92
cmSYM_GET               Equ     CORE_CP Or 93
cmSYM_FLUSH             Equ     CORE_CP Or 94
cmSYM_INIT              Equ     CORE_CP Or 96
cmHBM_CALLOC            Equ     CORE_CP Or 97
cmHBM_FCALLOC           Equ     CORE_CP Or 98
cmFLUSH_MODULE          Equ     CORE_CP Or 99


;-------------------------------------------------------------------------;
;   Reference Core C-Packet function definitions                          ;
;-------------------------------------------------------------------------;

Add_Interrupt           Macro   __first, __sech, __secl
        _Dword          <__sech>, <__secl>
        _Word           <__first>
        _Call           _cp_ret, cmADD_INTERRUPT
                        Endm

Del_Interrupt           Macro   __first
        _Word           <__first>
        _Call           _cp_ret, cmDEL_INTERRUPT
                        Endm

Set_Interrupt           Macro   __level, __priority, __enable, __scanline
        _Sword          <__scanline>
        _Word           <__enable>
        _Word           <__priority>
        _Word           <__level>
        _Call           _cp_ret, cmSET_INTERRUPT
                        Endm

Function_Implemented    Macro   __fid
        _Word           <__fid>
        _Call           _cp_ret, cmFUNCTION_IMPLEMENTED
                        Endm

Get_Colors              Macro   __fptrseg, __fptroff, __bptrseg, __bptroff
        _AltDword_Ptr   1, <__bptrseg>, <__bptroff>
        _AltDword_Ptr   1, <__fptrseg>, <__fptroff>
        _Call           _cp_alt, cmGET_COLORS
                        Endm

Get_Config              Macro   __ptrseg, __ptroff
        _AltByte_Ptr    <Size CONFIG>, <__ptrseg>, <__ptroff>
        _Call           _cp_alt, cmGET_CONFIG
                        Endm

GSP_MaxHeap             Macro
        _Call           _cp_ret, cmGSP_MAXHEAP
                        Endm

Get_OffScreen_Memory    Macro   __cnt, __ptrseg, __ptroff
        mov             ax,__cnt
        push            dx
        mov             dx,(Size OFFSCREEN_AREA)
        mul             dx
        pop             dx
        _AltByte_Ptr    ax, <__ptrseg>, <__ptroff>
        _Word           <__cnt>
        _Call           _cp_alt, cmGET_OFFSCREEN_MEMORY
                        Endm

Get_Palet_Entry         Macro   __indexhi, __indexlo, __rptrseg, __rptroff, __gptrseg, __gptroff, __bptrseg, __bptroff, __iptrseg, __iptroff
        _AltWord_Ptr    1, <__iptrseg>, <__iptroff>
        _AltWord_Ptr    1, <__bptrseg>, <__bptroff>
        _AltWord_Ptr    1, <__gptrseg>, <__gptroff>
        _AltWord_Ptr    1, <__rptrseg>, <__rptroff>
        _Dword          <__indexhi>, <__indexlo>
        _Call           _hook_get_pal_e, cmGET_PALET_ENTRY
                        Endm

Get_PMask               Macro
        _Call           _cp_ret, cmGET_PMASK
                        Endm

Get_PPOP                Macro
        _Call           _cp_ret, cmGET_PPOP
                        Endm

Get_Transp              Macro
        _Call           _cp_ret, cmGET_TRANSP
                        Endm

Get_Windowing           Macro
        _Call           _cp_ret, cmGET_WINDOWING
                        Endm

GSP_Calloc              Macro   __cnthi, __cntlo, __sizehi, __sizelo
        _Dword          <__sizehi>, <__sizelo>
        _Dword          <__cnthi>, <__cntlo>
        _Call           _cp_ret, cmGSP_CALLOC
                        Endm

GSP_Free                Macro   __lochi, __loclo
        _Dword          <__lochi>, <__loclo>
        _Call           _cp_ret, cmGSP_FREE
                        Endm

GSP_Malloc              Macro   __sizehi, __sizelo
        _Dword          <__sizehi>, <__sizelo>
        _Call           _cp_ret, cmGSP_MALLOC
                        Endm

GSP_Minit               Macro   __sizehi, __sizelo
        _Dword          <__sizehi>, <__sizelo>
        _Call           _cp_cmd, cmGSP_MINIT
                        Endm

GSP_Realloc             Macro   __ptrhi, __ptrlo, __sizehi, __sizelo
        _Dword          <__sizehi>, <__sizelo>
        _Dword          <__ptrhi>, <__ptrlo>
        _Call           _cp_ret, cmGSP_REALLOC
                        Endm

Init_Cursor             Macro
        _Call           _cp_ret, cmINIT_CURSOR
                        Endm

Page_Flip               Macro   __disp, __draw
        _Word           <__draw>
        _Word           <__disp>
        _Call           _cp_cmd, cmPAGE_FLIP
                        Endm

Set_Palet               Macro   __cnthi, __cntlo, __starthi, __startlo, __ptrseg, __ptroff
        mov             ax,__cntlo
        shl             ax,1
        rcl             __cnthi,1
        shl             ax,1
        rcl             __cnthi,1
        _Byte_Ptr       ax, <__ptrseg>, <__ptroff>
        _Dword          <__starthi>, <__startlo>
        _Dword          <__cnthi>, <__cntlo>
        _Call           _hook_set_pal, cmSET_PALET
                        Endm

Transp_Off              Macro
        _Call           _cp_cmd, cmTRANSP_OFF
                        Endm

Transp_On               Macro
        _Call           _cp_cmd, cmTRANSP_ON
                        Endm

Add_Module              Macro   __first, __ptrseg, __ptroff
        _Byte_Ptr       <Size MODULE>, <__ptrseg>, <__ptroff>
        _Sword          <__first>
        _Call           _cp_ret, cmADD_MODULE
                        Endm

Get_State               Macro
        _Call           _cp_ret, cmGET_STATE
                        Endm

Del_Module              Macro   __first
        _Word           <__first>
        _Call           _cp_ret, cmDEL_MODULE
                        Endm

Del_All_Modules         Macro
        _Call           _cp_cmd, cmDEL_ALL_MODULES
                        Endm

Wait_Scan               Macro   __line
        _Word           <__line>
        _Call           _cp_ret, cmWAIT_SCAN
                        Endm

Get_ISR_Priorities      Macro   __cnt, __ptrseg, __ptroff
        _AltWord_Ptr    <__cnt>, <__ptrseg>, <__ptroff>
        _Word           <__cnt>
        _Call           _cp_alt, cmGET_ISR_PRIORITIES
                        Endm

Get_Curs_State          Macro
        _Call           _cp_ret, cmGET_CURS_STATE
                        Endm

Get_Curs_XY             Macro   __xptrseg, __xptroff, __yptrseg, __yptroff
        _AltWord_Ptr    1, <__yptrseg>, <__yptroff>
        _AltWord_Ptr    1, <__xptrseg>, <__xptroff>
        _Call           _cp_alt, cmGET_CURS_XY
                        Endm

Get_Palet               Macro   __cnt, __ptrhi, __ptrlo
        _AltDword_Ptr   <__cnt>, <__ptrhi>, <__ptrlo>
        _Word           <__cnt>
        _Call           _hook_get_pal, cmGET_PALET
                        Endm

Flush_Extended          Macro
        _Call           _cp_cmd, cmFLUSH_EXTENDED
                        Endm

Page_Busy               Macro
        _Call           _cp_ret, cmPAGE_BUSY
                        Endm

Get_WKSP                Macro   __addrseg, __addroff, __pitchseg, __pitchoff
        _AltDword_Ptr   1, <__pitchseg>, <__pitchoff>
        _AltDword_Ptr   1, <__addrseg>, <__addroff>
        _Call           _cp_alt, cmGET_WKSP
                        Endm

Init_Text               Macro
        _Call           _cp_cmd,cmINIT_TEXT
                        Endm

Text_Out                Macro   __x, __y, __strseg, __stroff
        _String         <__strseg>, <__stroff>
        _Sword          <__y>
        _Sword          <__x>
        _Call           _cp_ret, cmTEXT_OUT
                        Endm

Get_FontInfo            Macro   __id, __ptrseg, __ptroff
        _AltByte_Ptr    <Size FONTINFO>, <__ptrseg>, <__ptroff>
        _Sword          <__id>
        _Call           _cp_alt, cmGET_FONTINFO
                        Endm

Get_Module              Macro   __first, __ptrseg, __ptroff
        _AltByte_Ptr    <Size MODULE>, <__ptrseg>, <__ptroff>
        _Word           <__first>
        _Call           _cp_alt, cmGET_MODULE
                        Endm

Get_Text_XY             Macro   __xptrseg, __xptroff, __yptrseg, __yptroff
        _AltWord_Ptr    1, <__yptrseg>, <__yptroff>
        _AltWord_Ptr    1, <__xptrseg>, <__xptroff>
        _Call           _cp_alt, cmGET_TEXT_XY
                        Endm

gsph_deref              Macro  __a
        _Word           <__a>
        _Call           _cp_ret, cmHBM_DEREF
                        Endm

gsph_memtype            Macro  __a,__b
        _Word           <__a>
        _Word           <__b>
        _Call           _cp_cmd, cmHBM_SETMEMTYPE
                        Endm

gsph_alloc              Macro  __ahi,__alow
        _DWord          <__ahi>,<__alow>
        _Call           _cp_ret, cmHBM_ALLOC
                        Endm

gsph_calloc             Macro  __ahi,__alow,__bhi,__blow
        _DWord          <__ahi>,<__alow>
        _DWord          <__bhi>,<__blow>
        _Call           _cp_ret, cmHBM_CALLOC
                        Endm

gsph_falloc             Macro  __ahi,__alow,__bhi,__blow,__c
        _DWord          <__ahi>,<__alow>
        _DWord          <__bhi>,<__blow>
        _Word           <__c>
        _Call           _cp_ret, cmHBM_FALLOC
                        Endm

gsph_fcalloc            Macro  __ahi,__alow,__bhi,__blow,__chi,__clow,__d
        _DWord          <__ahi>,<__alow>
        _DWord          <__bhi>,<__blow>
        _DWord          <__chi>,<__clow>
        _Word           <__d>
        _Call           _cp_ret, cmHBM_FCALLOC
                        Endm

gsph_free               Macro  __a
        _Word           <__a>
        _Call           _cp_cmd, cmHBM_FREE
                        Endm

gsph_totalfree          Macro
        _Call           _cp_ret, cmHBM_TOTALFREE
                        Endm

gsph_maxheap            Macro
        _Call           _cp_ret, cmHBM_MAXHEAP
                        Endm

gsph_compact            Macro __a
        _Word           <__a>
        _Call           _cp_cmd, cmHBM_COMPACT
                        Endm

gsph_realloc            Macro __a,__bhi,_blow
        _Word           <__a>
        _DWord          <__bhi>,<__blow>
        _Call           _cp_ret, cmHBM_REALLOC
                        Endm

gsph_findmem            Macro  __ahi,__alow,__ptrseg1,__ptroff1,__ptrseg2,__ptroff2
        _DWord          <__ahi>,<__alow>
        _AltWord_Ptr    1, <__ptrseg1>, <__ptroff1>
        _AltByte_Ptr    1, <__ptrseg2>, <__ptroff2>
        _Call           _cp_alt, cmHBM_FINDMEM
                        Endm

gsph_findhandle         Macro  __ahi,__alow
        _DWord          <__ahi>,<__alow>
        _Call           _cp_ret, cmHBM_FINDHANDLE
                        Endm

gsph_init               Macro
        _Call           _cp_cmd, cmHBM_INIT
                        Endm

sym_init                Macro
        _Call           _cp_cmd, cmSYM_INIT
                        Endm

sym_open                Macro   __modid
        _Sword          <__modid>
        _Call           _cp_ret, cmSYM_OPEN
                        Endm

sym_close               Macro
        _Call           _cp_cmd, cmSYM_CLOSE
                        Endm

sym_put                 Macro   __strseg, __stroff, __valhi,__vallow
        _DWord          <__valhi>,<__vallow>
        _String         <__strseg>, <__stroff>
        _Call           _cp_ret, cmSYM_PUT
                        Endm

sym_get                 Macro   __strseg, __stroff
        _String         <__strseg>, <__stroff>
        _Call           _cp_ret, cmSYM_GET
                        Endm

sym_flush               Macro   __modid
        _Sword          <__modid>
        _Call           _cp_ret, cmSYM_FLUSH
                        Endm

Cop2GSP                 Macro   __copid, __copadrl, __copadrh, __gspadrl, __gspadrh, __lenl, __lenh
        _Dword          <__lenh>, <__lenl>
        _Dword          <__gspadrh>, <__gspadrl>
        _Dword          <__copadrh>, <__copadrl>
        _Word           <__copid>
        _Call           _cp_cmd, cmCOP2GSP
                        Endm

GSP2Cop                 Macro   __copid, __gspadrl, __gspadrh, __copadrl, __copadrh, __lenl, __lenh
        _Dword          <__lenh>, <__lenl>
        _Dword          <__copadrh>, <__copadrl>
        _Dword          <__gspadrh>, <__gspadrl>
        _Word           <__copid>
        _Call           _cp_cmd, cmGSP2COP
                        Endm

Flush_Module            Macro __a
        _Word           <__a>
        _Call           _cp_ret, cmFLUSH_MODULE
                        Endm

;-------------------------------------------------------------------------;
;  Reference Core Direct-Mode function definitions                        ;
;-------------------------------------------------------------------------;

Clear_Screen            Macro   __colorhi, __colorlo
        $Dword          <__colorhi>, <__colorlo>
        $Call           _dm_cmd, cmCLEAR_SCREEN
                        Endm

Get_Nearest_Color       Macro   __r, __g, __b, __i
        $Word           <__i>
        $Word           <__b>
        $Word           <__g>
        $Word           <__r>
        $Call           _hook_get_near, cmGET_NEAREST_COLOR
                        Endm

Init_Palet              Macro
        $CALL           _hook_init_pal, cmINIT_PALET
                        Endm

LMO                     Macro   __lochi, __loclo
        $Dword          <__lochi>, <__loclo>
        $Call           _dm_ret, cmLMO
                        Endm

Peek_Breg               Macro   __breg
        $Word           <__breg>
        $Call           _dm_ret, cmPEEK_BREG
                        Endm

Poke_Breg               Macro   __breg, __valhi, __vallo
        $Dword          <__valhi>, <__vallo>
        $Word           <__breg>
        $Call           _dm_cmd, cmPOKE_BREG
                        Endm

RMO                     Macro   __lochi, __loclo
        $Dword          <__lochi>, <__loclo>
        $Call           _dm_ret, cmRMO
                        Endm

Set_Bcolor              Macro   __colorhi, __colorlo
        $Dword          <__colorhi>, <__colorlo>
        $Call           _dm_cmd, cmSET_BCOLOR
                        Endm

Set_Colors              Macro   __fcolorhi, __fcolorlo, __bcolorhi, __bcolorlo
        $Dword          <__bcolorhi>, <__bcolorlo>
        $Dword          <__fcolorhi>, <__fcolorlo>
        $Call           _dm_cmd, cmSET_COLORS
                        Endm

Set_Fcolor              Macro   __colorhi, __colorlo
        $Dword          <__colorhi>, <__colorlo>
        $Call           _dm_cmd, cmSET_FCOLOR
                        Endm

Set_Palet_Entry         Macro   __indexhi, __indexlo, __r, __g, __b, __i
        $Word           <__i>
        $Word           <__b>
        $Word           <__g>
        $Word           <__r>
        $Dword          <__indexhi>, <__indexlo>
        $Call           _hook_set_pal_e, cmSET_PALET_ENTRY
                        Endm

Set_Pmask               Macro   __maskhi, __masklo
        $Dword          <__maskhi>, <__masklo>
        $Call           _dm_cmd, cmSET_PMASK
                        Endm

Set_PPOP                Macro   __ppop
        $Word           <__ppop>
        $Call           _dm_cmd, cmSET_PPOP
                        Endm

Set_Windowing           Macro   __enable
        $Word           <__enable>
        $Call           _dm_cmd, cmSET_WINDOWING
                        Endm

Set_Clip_Rect           Macro   __first, __second, __third, __fourth
        $Word           <__fourth>
        $Word           <__third>
        $Word           <__second>
        $Word           <__first>
        $Call           _dm_cmd, cmSET_CLIP_RECT
                        Endm

Set_WKSP                Macro   __lochi, __loclo, __pitchhi, __pitchlo
        $Dword          <__pitchhi>, <__pitchlo>
        $Dword          <__lochi>, <__loclo>
        $Call           _dm_cmd, cmSET_WKSP
                        Endm

GSP2GSP                 Macro   __sptrhi, __sptrlo, __dptrhi, __dptrlo, __lengthhi, __lengthlo
        $Dword          <__lengthhi>, <__lengthlo>
        $Dword          <__dptrhi>, <__dptrlo>
        $Dword          <__sptrhi>, <__sptrlo>
        $Call           _dm_cmd, cmGSP2GSP
                        Endm

Set_Curs_State          Macro   __enable
        $Word           <__enable>
        $Call           _dm_cmd, cmSET_CURS_STATE
                        Endm

Clear_Frame_Buffer      Macro   __colorhi, __colorlo
        $Dword          <__colorhi>, <__colorlo>
        $Call           _dm_cmd, cmCLEAR_FRAME_BUFFER
                        Endm

Clear_Page              Macro   __colorhi, __colorlo
        $Dword          <__colorhi>, <__colorlo>
        $Call           _dm_cmd, cmCLEAR_PAGE
                        Endm

CPW                     Macro   __x, __y
        $Word           <__y>
        $Word           <__x>
        $Call           _dm_ret, cmCPW
                        Endm

Set_Transp              Macro   __mode
        $Word           <__mode>
        $Call           _dm_cmd, cmSET_Transp
                        Endm

Cvxyl                   Macro   __x, __y
        $Word           <__y>
        $Word           <__x>
        $Call           _dm_ret, cmCVXYL
                        Endm

Set_Cursattr            Macro   __schi, __sclo, __mchi, __mclo, __sa, __ma
        $Word           <__ma>
        $Word           <__sa>
        $Dword          <__mchi>, <__mclo>
        $Dword          <__schi>, <__sclo>
        $Call           _dm_cmd, cmSET_CURSATTR
                        Endm

Text_Outp               Macro   __sptrseg, __sptroff
        $Dword          <__sptrseg>, <__sptroff>        
        $Call           _dm_pstr, cmTEXT_OUTP
                        Endm
                        

;----------------------------------------------------------------------;
;  Arguments for tiga_set()                                            ;
;----------------------------------------------------------------------;
CD_CLOSE         equ     0
CD_OPEN          equ     1
CD_STATUS        equ     2
CD_NOT_INSTALLED equ     -4

;-------------------------------------------------------------------------;
;   Arguments for set_videomode()                                         ;
;-------------------------------------------------------------------------;
; Legal video modes
TIGA            Equ     -1
PREVIOUS        Equ     0
MDA             Equ     1
HERCULES        Equ     2
CGA             Equ     3
EGA             Equ     4
VGA             Equ     5
AI_8514         Equ     6
OFF_MODE        Equ     7
;
; Legal styles
NO_INIT         Equ     0
INIT_GLOBALS    Equ     1
INIT            Equ     3
INIT_GM         Equ     7
NO_ENABLE       Equ     04000h
CLR_SCREEN      Equ     08000h

;-------------------------------------------------------------------------;
; Colors of the default TIGA palet                                        ;
;-------------------------------------------------------------------------;
BLACK           Equ     0
BLUE            Equ     1
GREEN           Equ     2
CYAN            Equ     3
RED             Equ     4
MAGENTA         Equ     5
BROWN           Equ     6
LIGHT_GRAY      Equ     7
DARK_GRAY       Equ     8
LIGHT_BLUE      Equ     9
LIGHT_GREEN     Equ     10
LIGHT_CYAN      Equ     11
LIGHT_RED       Equ     12
LIGHT_MAGENTA   Equ     13
YELLOW          Equ     14
WHITE           Equ     15

;----------------------------------;
; Memory System Equates            ;
;----------------------------------;
BLK_DELETABLE   Equ     01h   ; Block can be deleted
BLK_LOCKED      Equ     02h   ; Block is locked
BLK_FUNCMOVE    Equ     04h   ; Call block function on move
BLK_FUNCDELETE  Equ     08h   ; Call block function on purge
BLK_SECURED     Equ     10h   ; Block is allocated
BLK_INUSE       Equ     20h   ; Block was allocated by system

;----------------------------------;
; Extended primitives module id    ;
; - parameter to sym_flush         ;
;----------------------------------;
GRAPHICS_LIB_ID Equ     03C00h

